{ ... }@args:

with builtins;

let
  fix = f: let x = f x; in x;

  readTree = import ./nix/readtree {};

  # Tracking nixos-unstable as of 2021-08-11.
  nixpkgsCommit = "42aae6fa748a41ced37373fc6d914de512658178";
  nixpkgsSrc = fetchTarball {
    url = "https://github.com/NixOS/nixpkgs/archive/${nixpkgsCommit}.tar.gz";
    sha256 = "I7oAGC1Ldm5kcryUQxLubMmMCj5o0n+JSLVGRCL0wm8=";
  };
  nixpkgs = import nixpkgsSrc {
    config.allowUnfree = true;
    config.allowBroken = true;

    # Nixpkgs marked this package as insecure.
    # We need it for HTML-to-PDF conversion.
    config.permittedInsecurePackages = [
      "qtwebkit-5.212.0-alpha4"
    ];
  };

  resForPkgs = pkgs: fix (self: (readTree rec {
    hscloud = self;
    inherit pkgs;
    pkgsSrc = pkgs.path;
    inherit (pkgs) lib stdenv;
    hscloudForPkgs = pkgs: resForPkgs pkgs;
  } ./.));

in (resForPkgs nixpkgs) // {
  root = ./.;
  pkgs = nixpkgs;
}
